Index: trunk/cfg/3D-HEVC/NonCTC/misc/fullCfg_31view.cfg
===================================================================
--- trunk/cfg/3D-HEVC/NonCTC/misc/fullCfg_31view.cfg	(revision 1413)
+++ trunk/cfg/3D-HEVC/NonCTC/misc/fullCfg_31view.cfg	(revision 1413)
@@ -0,0 +1,669 @@
+#======== Legend for comments ===================== 
+# (m) specification per layer/dimension/layerset possible
+# (c) cyclic repetition of values, if not given for all layers/dimensions/layersets. (e.g. 5 layers and 1 2 3 -> 1 2 3 1 2  )
+
+#======== File I/O =====================
+
+InputFile_0                   :                              
+InputFile_1                   : 
+InputFile_2                   : 
+InputFile_3                   : 
+InputFile_4                   : 
+InputFile_5                   : 
+InputFile_6                   : 
+InputFile_7                   : 
+InputFile_8                   : 
+InputFile_9                   : 
+InputFile_10                  : 
+InputFile_11                  : 
+InputFile_12                  : 
+InputFile_13                  : 
+InputFile_14                  : 
+InputFile_15                  : 
+InputFile_16                  : 
+InputFile_17                  : 
+InputFile_18                  : 
+InputFile_19                  : 
+InputFile_20                  : 
+InputFile_21                  : 
+InputFile_22                  : 
+InputFile_23                  : 
+InputFile_24                  : 
+InputFile_25                  : 
+InputFile_26                  : 
+InputFile_27                  : 
+InputFile_28                  : 
+InputFile_29                  : 
+InputFile_30                  : 
+InputFile_31                  : 
+InputFile_32                  : 
+InputFile_33                  : 
+InputFile_34                  : 
+InputFile_35                  : 
+InputFile_36                  : 
+InputFile_37                  : 
+InputFile_38                  : 
+InputFile_39                  : 
+InputFile_40                  : 
+InputFile_41                  : 
+InputFile_42                  : 
+InputFile_43                  : 
+InputFile_44                  : 
+InputFile_45                  : 
+InputFile_46                  : 
+InputFile_47                  : 
+InputFile_48                  : 
+InputFile_49                  : 
+InputFile_50                  : 
+InputFile_51                  : 
+InputFile_52                  : 
+InputFile_53                  : 
+InputFile_54                  : 
+InputFile_55                  : 
+InputFile_56                  : 
+InputFile_57                  : 
+InputFile_58                  : 
+InputFile_59                  : 
+InputFile_60                  : 
+InputFile_61                  : 
+InputFile_62                  : 
+InputFile_63                  :
+InputFile_64                  :
+InputFile_65                  :
+InputFile_66                  :
+InputFile_67                  :
+InputFile_68                  :
+InputFile_69                  :
+InputFile_70                  :
+InputFile_71                  :
+InputFile_72                  :
+InputFile_73                  :
+InputFile_74                  :
+InputFile_75                  :
+InputFile_76                  :
+InputFile_77                  :
+InputFile_78                  :
+InputFile_79                  :
+InputFile_80                  :
+InputFile_81                  :
+InputFile_82                  :
+InputFile_83                  :
+InputFile_84                  :
+InputFile_85                  :
+InputFile_86                  :
+InputFile_87                  :
+InputFile_88                  :
+InputFile_89                  :
+InputFile_90                  :
+InputFile_91                  :
+InputFile_92                  :
+InputFile_93                  :
+InputFile_94                  :
+InputFile_95                  :
+InputFile_96                  :
+InputFile_97                  :
+InputFile_98                  :
+InputFile_99                  :
+InputFile_100                 :
+InputFile_101                 :
+InputFile_102                 :
+InputFile_103                 :
+InputFile_104                 :
+InputFile_105                 :
+InputFile_106                 :
+InputFile_107                 :
+InputFile_108                 :
+InputFile_109                 :
+InputFile_110                 :
+InputFile_111                 :
+InputFile_112                 :
+InputFile_113                 :
+InputFile_114                 :
+InputFile_115                 :
+InputFile_116                 :
+InputFile_117                 :
+InputFile_118                 :
+InputFile_119                 :
+InputFile_120                 :
+InputFile_121                 :
+InputFile_122                 :
+InputFile_123                 :
+InputFile_124                 :
+InputFile_125                 :
+InputFile_126                 :
+InputFile_127                 :
+
+
+
+BitstreamFile                 : stream.bit                         
+
+ReconFile_0                   :                              
+ReconFile_1                   : 
+ReconFile_2                   : 
+ReconFile_3                   : 
+ReconFile_4                   : 
+ReconFile_5                   : 
+ReconFile_6                   : 
+ReconFile_7                   : 
+ReconFile_8                   : 
+ReconFile_9                   : 
+ReconFile_10                  : 
+ReconFile_11                  : 
+ReconFile_12                  : 
+ReconFile_13                  : 
+ReconFile_14                  : 
+ReconFile_15                  : 
+ReconFile_16                  : 
+ReconFile_17                  : 
+ReconFile_18                  : 
+ReconFile_19                  : 
+ReconFile_20                  : 
+ReconFile_21                  : 
+ReconFile_22                  : 
+ReconFile_23                  : 
+ReconFile_24                  : 
+ReconFile_25                  : 
+ReconFile_26                  : 
+ReconFile_27                  : 
+ReconFile_28                  : 
+ReconFile_29                  : 
+ReconFile_30                  : 
+ReconFile_31                  : 
+ReconFile_32                  : 
+ReconFile_33                  : 
+ReconFile_34                  : 
+ReconFile_35                  : 
+ReconFile_36                  : 
+ReconFile_37                  : 
+ReconFile_38                  : 
+ReconFile_39                  : 
+ReconFile_40                  : 
+ReconFile_41                  : 
+ReconFile_42                  : 
+ReconFile_43                  : 
+ReconFile_44                  : 
+ReconFile_45                  : 
+ReconFile_46                  : 
+ReconFile_47                  : 
+ReconFile_48                  : 
+ReconFile_49                  : 
+ReconFile_50                  : 
+ReconFile_51                  : 
+ReconFile_52                  : 
+ReconFile_53                  : 
+ReconFile_54                  : 
+ReconFile_55                  : 
+ReconFile_56                  : 
+ReconFile_57                  : 
+ReconFile_58                  : 
+ReconFile_59                  : 
+ReconFile_60                  : 
+ReconFile_61                  : 
+ReconFile_62                  : 
+ReconFile_63                  :
+ReconFile_64                  :
+ReconFile_65                  :
+ReconFile_66                  :
+ReconFile_67                  :
+ReconFile_68                  :
+ReconFile_69                  :
+ReconFile_70                  :
+ReconFile_71                  :
+ReconFile_72                  :
+ReconFile_73                  :
+ReconFile_74                  :
+ReconFile_75                  :
+ReconFile_76                  :
+ReconFile_77                  :
+ReconFile_78                  :
+ReconFile_79                  :
+ReconFile_80                  :
+ReconFile_81                  :
+ReconFile_82                  :
+ReconFile_83                  :
+ReconFile_84                  :
+ReconFile_85                  :
+ReconFile_86                  :
+ReconFile_87                  :
+ReconFile_88                  :
+ReconFile_89                  :
+ReconFile_90                  :
+ReconFile_91                  :
+ReconFile_92                  :
+ReconFile_93                  :
+ReconFile_94                  :
+ReconFile_95                  :
+ReconFile_96                  :
+ReconFile_97                  :
+ReconFile_98                  :
+ReconFile_99                  :
+ReconFile_100                 :
+ReconFile_101                 :
+ReconFile_102                 :
+ReconFile_103                 :
+ReconFile_104                 :
+ReconFile_105                 :
+ReconFile_106                 :
+ReconFile_107                 :
+ReconFile_108                 :
+ReconFile_109                 :
+ReconFile_110                 :
+ReconFile_111                 :
+ReconFile_112                 :
+ReconFile_113                 :
+ReconFile_114                 :
+ReconFile_115                 :
+ReconFile_116                 :
+ReconFile_117                 :
+ReconFile_118                 :
+ReconFile_119                 :
+ReconFile_120                 :
+ReconFile_121                 :
+ReconFile_122                 :
+ReconFile_123                 :
+ReconFile_124                 :
+ReconFile_125                 :
+ReconFile_126                 :
+ReconFile_127                 :
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+NumberOfLayers                : 62          # Number of layers
+
+TargetEncLayerIdList          :             # Layer Id in Nuh to be encoded, (empty:-> all layers will be encode) 
+
+FramesToBeEncoded             : 3           # Number of frames to be coded
+FrameRate                     : 30          # Frame Rate per second
+SourceWidth                   : 1024        # Input  frame width
+SourceHeight                  : 768         # Input  frame height
+
+
+OutputVpsInfo                 : 0           # Output VPS information
+
+
+#======== VPS ============================
+ScalabilityMask               : 3           # Scalability Mask             ( 2: View Scalability, 3: View + Depth Scalability )
+DimensionIdLen                : 1 8           # Number of bits to store Ids,  per scalability dimension, (m)
+ViewOrderIndex                : 0 0 1 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 21 21 22 22 23 23 24 24 25 25 26 26 27 27 28 28 29 29 30 30         # ViewOrderIndex, per layer (m)
+LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling, otherwise per layer ) (m)
+SplittingFlag                 : 0           # Splitting Flag 
+
+DepthFlag                     :   0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1  # DepthFlag  (m) 
+ViewId                        : 0 0 1 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 21 21 22 22 23 23 24 24 25 25 26 26 27 27 28 28 29 29 30 30
+AuxId                         :             # Auxiliary Id, per layer (m)
+
+#======== VPS / Layer sets ================
+VpsNumLayerSets               : 2            # Number of layer sets    
+LayerIdsInSet_0               : 0            # Indices in VPS of layers in layer set 0
+LayerIdsInSet_1               : 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61# Indices in VPS of layers in layer set 1
+
+
+ShareParameterSets            : 1
+
+
+
+
+
+#======== VPS / Output layer sets ================
+DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
+
+OutputLayerSetIdx             :              # Indices of layer sets used to derive additional output layer sets
+
+#======== VPS / PTLI ================
+Profile                       : main main 3d-main   # Profile indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+Level                         : none none none             # Level   indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+Tier                          : main main main             # Tier    indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+InblFlag                      : 0    0    0                # Inbl    indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
+
+ProfileTierLevelIdx_0         : 1                          # VpsProfileTierLevel indices of layers in output layer set 0 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_1         : 1 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 # VpsProfileTierLevel indices of layers in output layer set 1 (m) (should be -1, when layer is not necessary)
+
+#======== VPS / Dependencies ================
+DirectRefLayers_1              : 0           # Indices in VPS of direct reference layers 
+DirectRefLayers_2              : 0  1
+DirectRefLayers_3              : 1  2
+DirectRefLayers_4              : 2  3
+DirectRefLayers_5              : 3  4
+DirectRefLayers_6              : 4  5
+DirectRefLayers_7              : 5  6
+DirectRefLayers_8              : 0  1
+DirectRefLayers_9              : 1  8
+DirectRefLayers_10             : 8  9
+DirectRefLayers_11             : 9  10
+DirectRefLayers_12             : 10  11
+DirectRefLayers_13             : 11  12
+DirectRefLayers_14             : 12  13
+DirectRefLayers_15             : 13  14
+DirectRefLayers_16             : 0   1 
+DirectRefLayers_17             : 1   16
+DirectRefLayers_18             : 16  17
+DirectRefLayers_19             : 17  18
+DirectRefLayers_20             : 18  19
+DirectRefLayers_21             : 19  20
+DirectRefLayers_22             : 20  21
+DirectRefLayers_23             : 21  22
+DirectRefLayers_24             : 0   1 
+DirectRefLayers_25             : 1   24
+DirectRefLayers_26             : 24  25
+DirectRefLayers_27             : 25  26
+DirectRefLayers_28             : 26  27
+DirectRefLayers_29             : 27  28
+DirectRefLayers_30             : 28  29
+DirectRefLayers_31             : 29  30
+DirectRefLayers_32             : 0   1  
+DirectRefLayers_33             : 1   32
+DirectRefLayers_34             : 32  33
+DirectRefLayers_35             : 33  34
+DirectRefLayers_36             : 34  35
+DirectRefLayers_37             : 35  36
+DirectRefLayers_38             : 36  37
+DirectRefLayers_39             : 37  38
+DirectRefLayers_40             : 0  1
+DirectRefLayers_41             : 1  40
+DirectRefLayers_42             : 40  41
+DirectRefLayers_43             : 41  42
+DirectRefLayers_44             : 42  43
+DirectRefLayers_45             : 43  44
+DirectRefLayers_46             : 44  45
+DirectRefLayers_47             : 45  46
+DirectRefLayers_48             :  0   1  
+DirectRefLayers_49             :  1  48
+DirectRefLayers_50             : 48  49
+DirectRefLayers_51             : 49  50
+DirectRefLayers_52             : 50  51
+DirectRefLayers_53             : 51  52
+DirectRefLayers_54             : 52  53
+DirectRefLayers_55             : 53  54
+DirectRefLayers_56             :  0   1  
+DirectRefLayers_57             :  1  56
+DirectRefLayers_58             : 56  57
+DirectRefLayers_59             : 57  58
+DirectRefLayers_60             : 58  59
+DirectRefLayers_61             : 59  60
+
+
+DependencyTypes_1              : 6
+DependencyTypes_2              : 2 0
+DependencyTypes_3              : 2 6
+DependencyTypes_4              : 2 0
+DependencyTypes_5              : 2 6
+DependencyTypes_6              : 2 0
+DependencyTypes_7              : 2 6
+DependencyTypes_8              : 2 0
+DependencyTypes_9              : 2 6
+DependencyTypes_10             : 2 0
+DependencyTypes_11             : 2 6
+DependencyTypes_12             : 2 0
+DependencyTypes_13             : 2 6
+DependencyTypes_14             : 2 0
+DependencyTypes_15             : 2 6
+DependencyTypes_16             : 2 0
+DependencyTypes_17             : 2 6
+DependencyTypes_18             : 2 0
+DependencyTypes_19             : 2 6
+DependencyTypes_20             : 2 0
+DependencyTypes_21             : 2 6
+DependencyTypes_22             : 2 0
+DependencyTypes_23             : 2 6
+DependencyTypes_24             : 2 0
+DependencyTypes_25             : 2 6
+DependencyTypes_26             : 2 0
+DependencyTypes_27             : 2 6
+DependencyTypes_28             : 2 0
+DependencyTypes_29             : 2 6
+DependencyTypes_30             : 2 0
+DependencyTypes_31             : 2 6
+DependencyTypes_32             : 2 0
+DependencyTypes_33             : 2 6
+DependencyTypes_34             : 2 0
+DependencyTypes_35             : 2 6
+DependencyTypes_36             : 2 0
+DependencyTypes_37             : 2 6
+DependencyTypes_38             : 2 0
+DependencyTypes_39             : 2 6
+DependencyTypes_40             : 2 0
+DependencyTypes_41             : 2 6
+DependencyTypes_42             : 2 0
+DependencyTypes_43             : 2 6
+DependencyTypes_44             : 2 0
+DependencyTypes_45             : 2 6
+DependencyTypes_46             : 2 0
+DependencyTypes_47             : 2 6
+DependencyTypes_48             : 2 0
+DependencyTypes_49             : 2 6
+DependencyTypes_50             : 2 0
+DependencyTypes_51             : 2 6
+DependencyTypes_52             : 2 0
+DependencyTypes_53             : 2 6
+DependencyTypes_54             : 2 0
+DependencyTypes_55             : 2 6
+DependencyTypes_56             : 2 0
+DependencyTypes_57             : 2 6
+DependencyTypes_58             : 2 0
+DependencyTypes_59             : 2 6
+DependencyTypes_60             : 2 0
+DependencyTypes_61             : 2 6
+
+
+#========== Camera parameters ==========
+BaseViewCameraNumbers         : 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31        # camera numbers of coded views ( in coding order per view )
+CameraParameterFile           : cam_pars.txt  # camera parameter file
+CodedCamParsPrecision         : 5           # precision used for coding of camera parameters (in units of 2^(-x) luma samples)
+
+
+#======== Unit definition ================
+MaxCUWidth                    : 64          # Maximum coding unit width in pixel
+MaxCUHeight                   : 64          # Maximum coding unit height in pixel
+MaxPartitionDepth             : 4           # Maximum coding unit depth
+QuadtreeTULog2MaxSize         : 5           # Log2 of maximum transform size for
+                                            # quadtree-based TU coding (2...6)
+QuadtreeTULog2MinSize         : 2           # Log2 of minimum transform size for
+                                            # quadtree-based TU coding (2...6)
+QuadtreeTUMaxDepthInter       : 3
+QuadtreeTUMaxDepthIntra       : 3
+
+#======== Coding Structure =============
+IntraPeriod                   : 24          # Period of I-Frame ( -1 = only first)
+DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CRA, 2:IDR, 3:Recovery Point SEI
+GOPSize                       : 8           # GOP Size (number of B slice = GOPSize-1)
+
+#                         CbQPoffset  QPfactor     betaOffsetDiv2   #ref_pics_active  reference pictures     deltaRPS     reference idcs          ilPredLayerIdc       refLayerPicPosIl_L1
+#         Type  POC QPoffset CrQPoffset  cOffsetDiv2      temporal_id   #ref_pics                 predict     #ref_idcs        #ActiveRefLayerPics     refLayerPicPosIl_L0         interCompPred     
+Frame1:     B    8     1    0   0     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 0                                            0
+Frame2:     B    4     2    0   0     0.3536   0        0        0        2      3     -4 -6  4           1     4     5     1 1 0 0 1       0                                            0
+Frame3:     B    2     3    0   0     0.3536   0        0        0        2      4     -2 -4  2 6         1     2     4     1 1 1 1         0                                            0
+Frame4:     B    1     4    0   0     0.68     0        0        0        2      4     -1  1  3 7         1     1     5     1 0 1 1 1       0                                            0
+Frame5:     B    3     4    0   0     0.68     0        0        0        2      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       0                                            0
+Frame6:     B    6     3    0   0     0.3536   0        0        0        2      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       0                                            0                                                
+Frame7:     B    5     4    0   0     0.68     0        0        0        2      4     -1 -5  1 3         1     1     5     1 0 1 1 1       0                                            0
+Frame8:     B    7     4    0   0     0.68     0        0        0        2      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       0                                            0
+                                                                              
+FrameI_l1:  I    0     0    0   0     0.442    0        0        0        0      0                        0                                 0                                            1                    
+Frame1_l1:  B    8     1    0   0     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 0                                            1             
+Frame2_l1:  B    4     2    0   0     0.3536   0        0        0        2      3     -4 -6  4           1     4     5     1 1 0 0 1       0                                            1             
+Frame3_l1:  B    2     3    0   0     0.3536   0        0        0        2      4     -2 -4  2 6         1     2     4     1 1 1 1         0                                            1             
+Frame4_l1:  B    1     4    0   0     0.68     0        0        0        2      4     -1  1  3 7         1     1     5     1 0 1 1 1       0                                            1             
+Frame5_l1:  B    3     4    0   0     0.68     0        0        0        2      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       0                                            1             
+Frame6_l1:  B    6     3    0   0     0.3536   0        0        0        2      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       0                                            1             
+Frame7_l1:  B    5     4    0   0     0.68     0        0        0        2      4     -1 -5  1 3         1     1     5     1 0 1 1 1       0                                            1             
+Frame8_l1:  B    7     4    0   0     0.68     0        0        0        2      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       0                                            1
+
+FrameI_l2:  P    0     3    0   0     0.442    0        0        0        1      0                        0                                 1            0         0          -1         1
+Frame1_l2:  B    8     4    0   0     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 1            0         1          -1         1
+Frame2_l2:  B    4     5    0   0     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       1            0         1          -1         1
+Frame3_l2:  B    2     6    0   0     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         1            0         1          -1         1
+Frame4_l2:  B    1     7    0   0     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       1            0         1          -1         1
+Frame5_l2:  B    3     7    0   0     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       1            0         2          -1         1
+Frame6_l2:  B    6     6    0   0     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       1            0         2          -1         1
+Frame7_l2:  B    5     7    0   0     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       1            0         2          -1         1
+Frame8_l2:  B    7     7    0   0     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       1            0         2          -1         1
+
+
+LayerIdxInVpsToGopDefIdx: 0 1 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2
+
+#=========== Motion Search =============
+FastSearch                    : 1           # 0:Full search  1:TZ search
+SearchRange                   : 64          # (0: Search range is a Full frame)
+BipredSearchRange             : 4           # Search range for bi-prediction refinement
+HadamardME                    : 1           # Use of hadamard measure for fractional ME
+FEN                           : 1           # Fast encoder decision
+FDM                           : 1           # Fast Decision for Merge RD cost
+
+#======== Quantization =============
+QP                            : 25 30       # QP ( mc )
+MaxDeltaQP                    : 0           # CU-based multi-QP optimization
+MaxCuDQPDepth                 : 0           # Max depth of a minimum CuDQP for sub-LCU-level delta QP
+DeltaQpRD                     : 0           # Slice-based multi-QP optimization
+RDOQ                          : 1           # RDOQ
+RDOQTS                        : 1           # RDOQ for transform skip
+SliceChromaQPOffsetPeriodicity: 0           # Used in conjunction with Slice Cb/Cr QpOffsetIntraOrPeriodic. Use 0 (default) to disable periodic nature.
+SliceCbQpOffsetIntraOrPeriodic: 0           # Chroma Cb QP Offset at slice level for I slice or for periodic inter slices as defined by SliceChromaQPOffsetPeriodicity. Replaces offset in the GOP table.
+SliceCrQpOffsetIntraOrPeriodic: 0           # Chroma Cr QP Offset at slice level for I slice or for periodic inter slices as defined by SliceChromaQPOffsetPeriodicity. Replaces offset in the GOP table.
+
+#=========== Deblock Filter ============
+
+LoopFilterOffsetInPPS         : 1           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1 (default) =constant params in PPS, param = base_param)
+LoopFilterDisable             : 0 1         # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream). Applies slice-level loop filter offsets (LoopFilterOffsetInPPS and LoopFilterDisable must be 0)
+
+#=========== Misc. ============
+InternalBitDepth              : 8           # codec operating bit-depth
+
+#=========== Coding Tools =================
+SAO                           : 1 0         # Sample adaptive offset  (0: OFF, 1: ON) (mc)
+AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
+TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
+TransformSkipFast             : 1           # Fast Transform skipping (0: OFF, 1: ON)
+SAOLcuBoundary                : 0           # SAOLcuBoundary using non-deblocked pixels (0: OFF, 1: ON)
+
+#============ Slices ================
+SliceMode                : 0                # 0: Disable all slice options.
+                                            # 1: Enforce maximum number of LCU in an slice,
+                                            # 2: Enforce maximum number of bytes in an 'slice'
+                                            # 3: Enforce maximum number of tiles in a slice
+SliceArgument            : 1500             # Argument for 'SliceMode'.
+                                            # If SliceMode==1 it represents max. SliceGranularity-sized blocks per slice.
+                                            # If SliceMode==2 it represents max. bytes per slice.
+                                            # If SliceMode==3 it represents max. tiles per slice.
+
+LFCrossSliceBoundaryFlag : 1                # In-loop filtering, including ALF and DB, is across or not across slice boundary.
+                                            # 0:not across, 1: across
+
+#============ PCM ================
+PCMEnabledFlag                      : 0                # 0: No PCM mode
+PCMLog2MaxSize                      : 5                # Log2 of maximum PCM block size.
+PCMLog2MinSize                      : 3                # Log2 of minimum PCM block size.
+PCMInputBitDepthFlag                : 1                # 0: PCM bit-depth is internal bit-depth. 1: PCM bit-depth is input bit-depth.
+PCMFilterDisableFlag                : 0                # 0: Enable loop filtering on I_PCM samples. 1: Disable loop filtering on I_PCM samples.
+
+#============ Tiles ================
+TileUniformSpacing                  : 0                # 0: the column boundaries are indicated by TileColumnWidth array, the row boundaries are indicated by TileRowHeight array
+                                                       # 1: the column and row boundaries are distributed uniformly
+NumTileColumnsMinus1                : 0                # Number of tile columns in a picture minus 1
+TileColumnWidthArray                : 2 3              # Array containing tile column width values in units of CTU (from left to right in picture)   
+NumTileRowsMinus1                   : 0                # Number of tile rows in a picture minus 1
+TileRowHeightArray                  : 2                # Array containing tile row height values in units of CTU (from top to bottom in picture)
+
+LFCrossTileBoundaryFlag           : 1                  # In-loop filtering is across or not across tile boundary.
+                                                       # 0:not across, 1: across                                                       
+
+#============ WaveFront ================
+WaveFrontSynchro                    : 0                # 0:  No WaveFront synchronisation (WaveFrontSubstreams must be 1 in this case).
+                                                       # >0: WaveFront synchronises with the LCU above and to the right by this many LCUs.
+
+#=========== Quantization Matrix =================
+ScalingList                   : 0                      # ScalingList 0 : off, 1 : default, 2 : file read
+ScalingListFile               : scaling_list.txt       # Scaling List file name. If file is not exist, use Default Matrix.
+
+#============ Lossless ================
+TransquantBypassEnableFlag: 0  # Value of PPS flag.
+CUTransquantBypassFlagForce: 0 # Constant lossless-value signaling per CU, if TransquantBypassEnableFlag is 1.
+
+#============ Rate Control ======================
+RateControl                         : 0                # Rate control: enable rate control
+TargetBitrate                       : 1000000          # Rate control: target bitrate, in bps
+KeepHierarchicalBit                 : 1                # Rate control: keep hierarchical bit allocation in rate control algorithm
+LCULevelRateControl                 : 1                # Rate control: 1: LCU level RC; 0: picture level RC
+RCLCUSeparateModel                  : 1                # Rate control: use LCU level separate R-lambda model
+InitialQP                           : 0                # Rate control: initial QP
+RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
+
+#DepthMADPred                        : 0                # 0: Disable Depth based MAD prediction for extended view 1: Enable Depth based MAD prediction for extended view
+#TargetBitAssign                     : 0                # Manual assignment of target bit-rate
+#ViewWiseTargetBits                  : 950000 315000 358000      # View-wise target bit-rate setting
+
+#============ Rate Control URQ ======================
+#RateCtrl                           : 0                # 0: Disable rate control 1: Enable rate control with total target
+#DepthMADPred                       : 0                # 0: Disable Depth based MAD prediction for extended view 1: Enable Depth based MAD prediction for extended view
+#TargetBitAssign                    : 0                # Manual assignment of target bit-rate
+#ViewWiseTargetBits                 : 952 315 360      # View-wise target bit-rate setting
+#TargetBitrate                      : 1500             # input target bitrate when RateCtrl is enable
+#NumLCUInUnit                       : 1                # Number of LCU in an Unit. Fraction is not allowed
+#========== multiview coding tools ==========
+IvMvPredFlag                        : 1 1              # Inter-view motion prediction
+IvResPredFlag                       : 1                # Advanced inter-view residual prediction (0:off, 1:on)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on ) (v/d)
+IlluCompLowLatencyEnc               : 0                # Enable low-latency Illumination compensation encoding( 0: off, 1: on )
+ViewSynthesisPredFlag               : 1                # View synthesis prediction 
+DepthRefinementFlag                 : 1                # Disparity refined by depth DoNBDV
+IvMvScalingFlag                     : 1                # Interview motion vector scaling
+Log2SubPbSizeMinus3                 : 0                # Log2 of sub-PU size for IvMvPred (2...6)
+Log2MpiSubPbSizeMinus3              : 0                # Log2 of sub-PU size minus 3 for MPI (0 ... 3) and smaller than or equal to log2(maxCUSize)-3
+DepthBasedBlkPartFlag               : 1                # Depth-based Block Partitioning
+
+#========== depth coding tools ==========
+VSO                                 : 0                # use of view synthesis optimization for depth coding
+IntraWedgeFlag                      : 1
+IntraContourFlag                    : 1                 # use of intra-view prediction mode
+IntraSdcFlag                        : 1
+DLT                                 : 1
+QTL                                 : 1
+QtPredFlag                          : 1
+InterSdcFlag                        : 1                             # use of inter sdc
+MpiFlag                             : 1
+DepthIntraSkip                      : 1     
+
+#========== view synthesis optimization (VSO) ==========
+VSOConfig                 : [cx0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][cx2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string
+#VSOConfig                 : [ox0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][ox2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string for FCO = 1
+WVSO                      : 0                                    # use of WVSO (Depth distortion metric with a weighted depth fidelity term) 
+VSOWeight                 : 10                                   # weight of VSO ( in SAD case, cf. squared in SSE case )
+VSDWeight                 : 1                                    # weight of VSD ( in SAD case, cf. squared in SSE case )
+DWeight                   : 1                                    # weight of depth distortion itself ( in SAD case, cf. squared in SSE case )
+UseEstimatedVSD           : 0                                    # Model based VSD estimation instead of rendering based for some encoder decisions      
+
+
+WarnUnknowParameter       : 1
+#========== Supplemental enhancement information ==========
+SeiCfgFileName_0                    :                  
+SeiCfgFileName_1                    :                 
+SeiCfgFileName_2                    :                 
+SeiCfgFileName_3                    :                 
+SeiCfgFileName_4                    :                 
+SeiCfgFileName_5                    :                 
+SeiCfgFileName_6                    :                 
+SeiCfgFileName_7                    :                 
+SeiCfgFileName_8                    :                 
+SeiCfgFileName_9                    :                 
+SeiCfgFileName_10                   :                 
+SeiCfgFileName_11                   :                 
+SeiCfgFileName_12                   :                 
+SeiCfgFileName_13                   :                 
+SeiCfgFileName_14                   :                 
+
+
+### DO NOT ADD ANYTHING BELOW THIS LINE ###
+### DO NOT DELETE THE EMPTY LINE BELOW ###